(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('midi-json-parser-broker')) :
	typeof define === 'function' && define.amd ? define(['exports', 'midi-json-parser-broker'], factory) :
	(global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.midiJsonParser = {}, global.midiJsonParserBroker));
})(this, (function (exports, midiJsonParserBroker) { 'use strict';

	// This is the minified and stringified code of the midi-json-parser-worker package.
	var worker = "(()=>{var t={45:(t,e,r)=>{var n=r(738).default;t.exports=function(t,e){if(\"object\"!=n(t)||!t)return t;var r=t[Symbol.toPrimitive];if(void 0!==r){var o=r.call(t,e||\"default\");if(\"object\"!=n(o))return o;throw new TypeError(\"@@toPrimitive must return a primitive value.\")}return(\"string\"===e?String:Number)(t)},t.exports.__esModule=!0,t.exports.default=t.exports},243:function(t,e,r){!function(t,e){\"use strict\";var r=function(t){return void 0!==t.channel},n=function(t){return t.toString(16).toUpperCase().padStart(2,\"0\")},o=function(t){for(var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:t.byteLength-(e-t.byteOffset),o=e+t.byteOffset,i=[],a=new Uint8Array(t.buffer,o,r),u=0;u<r;u+=1)i[u]=n(a[u]);return i.join(\"\")},i=function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:t.byteLength-(e-t.byteOffset),n=e+t.byteOffset,o=new Uint8Array(t.buffer,n,r);return String.fromCharCode.apply(null,o)};function a(t,e){var r=Object.keys(t);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(t);e&&(n=n.filter((function(e){return Object.getOwnPropertyDescriptor(t,e).enumerable}))),r.push.apply(r,n)}return r}function u(t){for(var r=1;r<arguments.length;r++){var n=null!=arguments[r]?arguments[r]:{};r%2?a(Object(n),!0).forEach((function(r){e(t,r,n[r])})):Object.getOwnPropertyDescriptors?Object.defineProperties(t,Object.getOwnPropertyDescriptors(n)):a(Object(n)).forEach((function(e){Object.defineProperty(t,e,Object.getOwnPropertyDescriptor(n,e))}))}return t}var s=function(t){for(var e=new DataView(t),r=f(e),n=14,o=[],i=0,a=r.numberOfTracks;i<a;i+=1){var u=void 0,s=v(e,n);n=s.offset,u=s.track,o.push(u)}return{division:r.division,format:r.format,tracks:o}},c=function(t,e,r){var n,o=d(t,e),i=o.offset,a=o.value,s=t.getUint8(i);return u(u({},n=240===s?h(t,i+1):255===s?l(t,i+1):p(s,t,i+1,r)),{},{event:u(u({},n.event),{},{delta:a}),eventTypeByte:s})},f=function(t){if(t.byteLength<14)throw new Error(\"Expected at least 14 bytes instead of \".concat(t.byteLength));if(\"MThd\"!==i(t,0,4))throw new Error('Unexpected characters \"'.concat(i(t,0,4),'\" found instead of \"MThd\"'));if(6!==t.getUint32(4))throw new Error(\"The header has an unexpected length of \".concat(t.getUint32(4),\" instead of 6\"));var e=t.getUint16(8),r=t.getUint16(10);return{division:t.getUint16(12),format:e,numberOfTracks:r}},l=function(t,e){var r,a=t.getUint8(e),u=d(t,e+1),s=u.offset,c=u.value;if(1===a)r={text:i(t,s,c)};else if(2===a)r={copyrightNotice:i(t,s,c)};else if(3===a)r={trackName:i(t,s,c)};else if(4===a)r={instrumentName:i(t,s,c)};else if(5===a)r={lyric:i(t,s,c)};else if(6===a)r={marker:i(t,s,c)};else if(7===a)r={cuePoint:i(t,s,c)};else if(8===a)r={programName:i(t,s,c)};else if(9===a)r={deviceName:i(t,s,c)};else if(10===a||11===a||12===a||13===a||14===a||15===a)r={metaTypeByte:n(a),text:i(t,s,c)};else if(32===a)r={channelPrefix:t.getUint8(s)};else if(33===a)r={midiPort:t.getUint8(s)};else if(47===a)r={endOfTrack:!0};else if(81===a)r={setTempo:{microsecondsPerQuarter:(t.getUint8(s)<<16)+(t.getUint8(s+1)<<8)+t.getUint8(s+2)}};else if(84===a){var f,l=t.getUint8(s);96&l?32==(96&l)?f=25:64==(96&l)?f=29:96&~l||(f=30):f=24,r={smpteOffset:{frame:t.getUint8(s+3),frameRate:f,hour:31&l,minutes:t.getUint8(s+1),seconds:t.getUint8(s+2),subFrame:t.getUint8(s+4)}}}else if(88===a)r={timeSignature:{denominator:Math.pow(2,t.getUint8(s+1)),metronome:t.getUint8(s+2),numerator:t.getUint8(s),thirtyseconds:t.getUint8(s+3)}};else if(89===a)r={keySignature:{key:t.getInt8(s),scale:t.getInt8(s+1)}};else{if(127!==a)throw new Error('Cannot parse a meta event with a type of \"'.concat(n(a),'\"'));r={sequencerSpecificData:o(t,s,c)}}return{event:r,offset:s+c}},p=function(t,e,r,o){var i,a=128&t?null:o,u=(null===a?t:a)>>4,s=null===a?r:r-1;if(8===u)i={noteOff:{noteNumber:e.getUint8(s),velocity:e.getUint8(s+1)}},s+=2;else if(9===u){var c=e.getUint8(s),f=e.getUint8(s+1);i=0===f?{noteOff:{noteNumber:c,velocity:f}}:{noteOn:{noteNumber:c,velocity:f}},s+=2}else if(10===u)i={keyPressure:{noteNumber:e.getUint8(s),pressure:e.getUint8(s+1)}},s+=2;else if(11===u)i={controlChange:{type:e.getUint8(s),value:e.getUint8(s+1)}},s+=2;else if(12===u)i={programChange:{programNumber:e.getUint8(s)}},s+=1;else if(13===u)i={channelPressure:{pressure:e.getUint8(s)}},s+=1;else{if(14!==u)throw new Error('Cannot parse a midi event with a type of \"'.concat(n(u),'\"'));i={pitchBend:e.getUint8(s)|e.getUint8(s+1)<<7},s+=2}return i.channel=15&(null===a?t:a),{event:i,offset:s}},h=function(t,e){var r=d(t,e),n=r.offset,i=r.value;return{event:{sysex:o(t,n,i)},offset:n+i}},v=function(t,e){if(\"MTrk\"!==i(t,e,4))throw new Error('Unexpected characters \"'.concat(i(t,e,4),'\" found instead of \"MTrk\"'));for(var n=[],o=t.getUint32(e+4)+e+8,a=null,u=e+8;u<o;){var s=c(t,u,a),f=s.event,l=s.eventTypeByte;n.push(f),u=s.offset,r(f)&&(128&l)>0&&(a=l)}return{offset:u,track:n}},d=function(t,e){for(var r=e,n=0;;){var o=t.getUint8(r);if(r+=1,!(o>127))return{offset:r,value:n+=o};n+=127&o,n<<=7}};t.createWorker(self,{parse:function(t){var e=t.arrayBuffer;return{result:s(e)}}})}(r(623),r(693))},293:t=>{function e(t,e,r,n,o,i,a){try{var u=t[i](a),s=u.value}catch(t){return void r(t)}u.done?e(s):Promise.resolve(s).then(n,o)}t.exports=function(t){return function(){var r=this,n=arguments;return new Promise((function(o,i){var a=t.apply(r,n);function u(t){e(a,o,i,u,s,\"next\",t)}function s(t){e(a,o,i,u,s,\"throw\",t)}u(void 0)}))}},t.exports.__esModule=!0,t.exports.default=t.exports},389:function(t,e){!function(t){\"use strict\";var e=function(t){return function(e){var r=t(e);return e.add(r),r}},r=function(t){return function(e,r){return t.set(e,r),r}},n=void 0===Number.MAX_SAFE_INTEGER?9007199254740991:Number.MAX_SAFE_INTEGER,o=536870912,i=2*o,a=function(t,e){return function(r){var a=e.get(r),u=void 0===a?r.size:a<i?a+1:0;if(!r.has(u))return t(r,u);if(r.size<o){for(;r.has(u);)u=Math.floor(Math.random()*i);return t(r,u)}if(r.size>n)throw new Error(\"Congratulations, you created a collection of unique numbers which uses all available integers!\");for(;r.has(u);)u=Math.floor(Math.random()*n);return t(r,u)}},u=new WeakMap,s=r(u),c=a(s,u),f=e(c);t.addUniqueNumber=f,t.generateUniqueNumber=c}(e)},623:function(t,e,r){!function(t,e,r,n,o){\"use strict\";var i={INTERNAL_ERROR:-32603,INVALID_PARAMS:-32602,METHOD_NOT_FOUND:-32601},a=function(t,e){return Object.assign(new Error(t),{status:e})},u=function(t){return a('The requested method called \"'.concat(t,'\" is not supported.'),i.METHOD_NOT_FOUND)},s=function(t){return a('The handler of the method called \"'.concat(t,'\" returned no required result.'),i.INTERNAL_ERROR)},c=function(t){return a('The handler of the method called \"'.concat(t,'\" returned an unexpected result.'),i.INTERNAL_ERROR)},f=function(t){return a('The specified parameter called \"portId\" with the given value \"'.concat(t,'\" does not identify a port connected to this worker.'),i.INVALID_PARAMS)},l=function(t,n){return function(){var o=e(r.mark((function e(o){var i,a,f,l,p,h,v,d,g,y,m,b,w;return r.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(i=o.data,a=i.id,f=i.method,l=i.params,p=n[f],e.prev=2,void 0!==p){e.next=5;break}throw u(f);case 5:if(void 0!==(h=void 0===l?p():p(l))){e.next=8;break}throw s(f);case 8:if(!(h instanceof Promise)){e.next=14;break}return e.next=11,h;case 11:e.t0=e.sent,e.next=15;break;case 14:e.t0=h;case 15:if(v=e.t0,null!==a){e.next=21;break}if(void 0===v.result){e.next=19;break}throw c(f);case 19:e.next=25;break;case 21:if(void 0!==v.result){e.next=23;break}throw c(f);case 23:d=v.result,g=v.transferables,y=void 0===g?[]:g,t.postMessage({id:a,result:d},y);case 25:e.next=31;break;case 27:e.prev=27,e.t1=e.catch(2),m=e.t1.message,b=e.t1.status,w=void 0===b?-32603:b,t.postMessage({error:{code:w,message:m},id:a});case 31:case\"end\":return e.stop()}}),e,null,[[2,27]])})));return function(t){return o.apply(this,arguments)}}()},p=function(){return new Promise((function(t){var e=new ArrayBuffer(0),r=new MessageChannel,n=r.port1,o=r.port2;n.onmessage=function(e){var r=e.data;return t(null!==r)},o.postMessage(e,[e])}))};function h(t,e){var r=Object.keys(t);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(t);e&&(n=n.filter((function(e){return Object.getOwnPropertyDescriptor(t,e).enumerable}))),r.push.apply(r,n)}return r}function v(t){for(var e=1;e<arguments.length;e++){var r=null!=arguments[e]?arguments[e]:{};e%2?h(Object(r),!0).forEach((function(e){n(t,e,r[e])})):Object.getOwnPropertyDescriptors?Object.defineProperties(t,Object.getOwnPropertyDescriptors(r)):h(Object(r)).forEach((function(e){Object.defineProperty(t,e,Object.getOwnPropertyDescriptor(r,e))}))}return t}var d=new Map,g=function(t,n,i){return v(v({},n),{},{connect:function(e){var r=e.port;r.start();var i=t(r,n),a=o.generateUniqueNumber(d);return d.set(a,(function(){i(),r.close(),d.delete(a)})),{result:a}},disconnect:function(t){var e=t.portId,r=d.get(e);if(void 0===r)throw f(e);return r(),{result:null}},isSupported:function(){var t=e(r.mark((function t(){var e,n;return r.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:return t.next=2,p();case 2:if(!t.sent){t.next=14;break}if(!((e=i())instanceof Promise)){t.next=11;break}return t.next=8,e;case 8:t.t0=t.sent,t.next=12;break;case 11:t.t0=e;case 12:return n=t.t0,t.abrupt(\"return\",{result:n});case 14:return t.abrupt(\"return\",{result:!1});case 15:case\"end\":return t.stop()}}),t)})));function n(){return t.apply(this,arguments)}return n}()})},y=function(t,e){var r=g(y,e,arguments.length>2&&void 0!==arguments[2]?arguments[2]:function(){return!0}),n=l(t,r);return t.addEventListener(\"message\",n),function(){return t.removeEventListener(\"message\",n)}};t.createWorker=y,t.isSupported=p}(e,r(293),r(756),r(693),r(389))},633:(t,e,r)=>{var n=r(738).default;function o(){\"use strict\";t.exports=o=function(){return r},t.exports.__esModule=!0,t.exports.default=t.exports;var e,r={},i=Object.prototype,a=i.hasOwnProperty,u=\"function\"==typeof Symbol?Symbol:{},s=u.iterator||\"@@iterator\",c=u.asyncIterator||\"@@asyncIterator\",f=u.toStringTag||\"@@toStringTag\";function l(t,e,r,n){return Object.defineProperty(t,e,{value:r,enumerable:!n,configurable:!n,writable:!n})}try{l({},\"\")}catch(e){l=function(t,e,r){return t[e]=r}}function p(t,r,n,o){var i=r&&r.prototype instanceof d?r:d,a=Object.create(i.prototype);return l(a,\"_invoke\",function(t,r,n){var o=1;return function(i,a){if(3===o)throw Error(\"Generator is already running\");if(4===o){if(\"throw\"===i)throw a;return{value:e,done:!0}}for(n.method=i,n.arg=a;;){var u=n.delegate;if(u){var s=_(u,n);if(s){if(s===v)continue;return s}}if(\"next\"===n.method)n.sent=n._sent=n.arg;else if(\"throw\"===n.method){if(1===o)throw o=4,n.arg;n.dispatchException(n.arg)}else\"return\"===n.method&&n.abrupt(\"return\",n.arg);o=3;var c=h(t,r,n);if(\"normal\"===c.type){if(o=n.done?4:2,c.arg===v)continue;return{value:c.arg,done:n.done}}\"throw\"===c.type&&(o=4,n.method=\"throw\",n.arg=c.arg)}}}(t,n,new k(o||[])),!0),a}function h(t,e,r){try{return{type:\"normal\",arg:t.call(e,r)}}catch(t){return{type:\"throw\",arg:t}}}r.wrap=p;var v={};function d(){}function g(){}function y(){}var m={};l(m,s,(function(){return this}));var b=Object.getPrototypeOf,w=b&&b(b(P([])));w&&w!==i&&a.call(w,s)&&(m=w);var x=y.prototype=d.prototype=Object.create(m);function O(t){[\"next\",\"throw\",\"return\"].forEach((function(e){l(t,e,(function(t){return this._invoke(e,t)}))}))}function E(t,e){function r(o,i,u,s){var c=h(t[o],t,i);if(\"throw\"!==c.type){var f=c.arg,l=f.value;return l&&\"object\"==n(l)&&a.call(l,\"__await\")?e.resolve(l.__await).then((function(t){r(\"next\",t,u,s)}),(function(t){r(\"throw\",t,u,s)})):e.resolve(l).then((function(t){f.value=t,u(f)}),(function(t){return r(\"throw\",t,u,s)}))}s(c.arg)}var o;l(this,\"_invoke\",(function(t,n){function i(){return new e((function(e,o){r(t,n,e,o)}))}return o=o?o.then(i,i):i()}),!0)}function _(t,r){var n=r.method,o=t.i[n];if(o===e)return r.delegate=null,\"throw\"===n&&t.i.return&&(r.method=\"return\",r.arg=e,_(t,r),\"throw\"===r.method)||\"return\"!==n&&(r.method=\"throw\",r.arg=new TypeError(\"The iterator does not provide a '\"+n+\"' method\")),v;var i=h(o,t.i,r.arg);if(\"throw\"===i.type)return r.method=\"throw\",r.arg=i.arg,r.delegate=null,v;var a=i.arg;return a?a.done?(r[t.r]=a.value,r.next=t.n,\"return\"!==r.method&&(r.method=\"next\",r.arg=e),r.delegate=null,v):a:(r.method=\"throw\",r.arg=new TypeError(\"iterator result is not an object\"),r.delegate=null,v)}function U(t){this.tryEntries.push(t)}function j(t){var r=t[4]||{};r.type=\"normal\",r.arg=e,t[4]=r}function k(t){this.tryEntries=[[-1]],t.forEach(U,this),this.reset(!0)}function P(t){if(null!=t){var r=t[s];if(r)return r.call(t);if(\"function\"==typeof t.next)return t;if(!isNaN(t.length)){var o=-1,i=function r(){for(;++o<t.length;)if(a.call(t,o))return r.value=t[o],r.done=!1,r;return r.value=e,r.done=!0,r};return i.next=i}}throw new TypeError(n(t)+\" is not iterable\")}return g.prototype=y,l(x,\"constructor\",y),l(y,\"constructor\",g),g.displayName=l(y,f,\"GeneratorFunction\"),r.isGeneratorFunction=function(t){var e=\"function\"==typeof t&&t.constructor;return!!e&&(e===g||\"GeneratorFunction\"===(e.displayName||e.name))},r.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,y):(t.__proto__=y,l(t,f,\"GeneratorFunction\")),t.prototype=Object.create(x),t},r.awrap=function(t){return{__await:t}},O(E.prototype),l(E.prototype,c,(function(){return this})),r.AsyncIterator=E,r.async=function(t,e,n,o,i){void 0===i&&(i=Promise);var a=new E(p(t,e,n,o),i);return r.isGeneratorFunction(e)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},O(x),l(x,f,\"Generator\"),l(x,s,(function(){return this})),l(x,\"toString\",(function(){return\"[object Generator]\"})),r.keys=function(t){var e=Object(t),r=[];for(var n in e)r.unshift(n);return function t(){for(;r.length;)if((n=r.pop())in e)return t.value=n,t.done=!1,t;return t.done=!0,t}},r.values=P,k.prototype={constructor:k,reset:function(t){if(this.prev=this.next=0,this.sent=this._sent=e,this.done=!1,this.delegate=null,this.method=\"next\",this.arg=e,this.tryEntries.forEach(j),!t)for(var r in this)\"t\"===r.charAt(0)&&a.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=e)},stop:function(){this.done=!0;var t=this.tryEntries[0][4];if(\"throw\"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var r=this;function n(e){a.type=\"throw\",a.arg=t,r.next=e}for(var o=r.tryEntries.length-1;o>=0;--o){var i=this.tryEntries[o],a=i[4],u=this.prev,s=i[1],c=i[2];if(-1===i[0])return n(\"end\"),!1;if(!s&&!c)throw Error(\"try statement without catch or finally\");if(null!=i[0]&&i[0]<=u){if(u<s)return this.method=\"next\",this.arg=e,n(s),!0;if(u<c)return n(c),!1}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var n=this.tryEntries[r];if(n[0]>-1&&n[0]<=this.prev&&this.prev<n[2]){var o=n;break}}o&&(\"break\"===t||\"continue\"===t)&&o[0]<=e&&e<=o[2]&&(o=null);var i=o?o[4]:{};return i.type=t,i.arg=e,o?(this.method=\"next\",this.next=o[2],v):this.complete(i)},complete:function(t,e){if(\"throw\"===t.type)throw t.arg;return\"break\"===t.type||\"continue\"===t.type?this.next=t.arg:\"return\"===t.type?(this.rval=this.arg=t.arg,this.method=\"return\",this.next=\"end\"):\"normal\"===t.type&&e&&(this.next=e),v},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r[2]===t)return this.complete(r[4],r[3]),j(r),v}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r[0]===t){var n=r[4];if(\"throw\"===n.type){var o=n.arg;j(r)}return o}}throw Error(\"illegal catch attempt\")},delegateYield:function(t,r,n){return this.delegate={i:P(t),r,n},\"next\"===this.method&&(this.arg=e),v}},r}t.exports=o,t.exports.__esModule=!0,t.exports.default=t.exports},693:(t,e,r)=>{var n=r(736);t.exports=function(t,e,r){return(e=n(e))in t?Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t},t.exports.__esModule=!0,t.exports.default=t.exports},736:(t,e,r)=>{var n=r(738).default,o=r(45);t.exports=function(t){var e=o(t,\"string\");return\"symbol\"==n(e)?e:e+\"\"},t.exports.__esModule=!0,t.exports.default=t.exports},738:t=>{function e(r){return t.exports=e=\"function\"==typeof Symbol&&\"symbol\"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&\"function\"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?\"symbol\":typeof t},t.exports.__esModule=!0,t.exports.default=t.exports,e(r)}t.exports=e,t.exports.__esModule=!0,t.exports.default=t.exports},756:(t,e,r)=>{var n=r(633)();t.exports=n;try{regeneratorRuntime=n}catch(t){\"object\"==typeof globalThis?globalThis.regeneratorRuntime=n:Function(\"r\",\"regeneratorRuntime = r\")(n)}}},e={};function r(n){var o=e[n];if(void 0!==o)return o.exports;var i=e[n]={exports:{}};return t[n].call(i.exports,i,i.exports,r),i.exports}r.n=t=>{var e=t&&t.__esModule?()=>t.default:()=>t;return r.d(e,{a:e}),e},r.d=(t,e)=>{for(var n in e)r.o(e,n)&&!r.o(t,n)&&Object.defineProperty(t,n,{enumerable:!0,get:e[n]})},r.o=(t,e)=>Object.prototype.hasOwnProperty.call(t,e),(()=>{\"use strict\";r(243)})()})();"; // tslint:disable-line:max-line-length

	var blob = new Blob([worker], {
	  type: 'application/javascript; charset=utf-8'
	});
	var url = URL.createObjectURL(blob);
	var midiJsonParser = midiJsonParserBroker.load(url);
	var connect = midiJsonParser.connect;
	var disconnect = midiJsonParser.disconnect;
	var isSupported = midiJsonParser.isSupported;
	// @todo Remove type annotation when possible.
	var parseArrayBuffer = midiJsonParser.parseArrayBuffer;
	URL.revokeObjectURL(url);

	exports.connect = connect;
	exports.disconnect = disconnect;
	exports.isSupported = isSupported;
	exports.parseArrayBuffer = parseArrayBuffer;

}));
